#pragma once

#include <stdint.h>

#define KMENUITEM_ID(x) (void *)x

#define KMENUITEM_NORMAL    0
#define KMENUITEM_SUBMENU   1
#define KMENUITEM_SEPARATOR 2

#define KMENUITEM_SEPARATOR_WIDTH 170
#define KMENUITEM_SEPARATOR_HEIGHT 2

#define KMENU_LBORDER_SIZE 2
#define KMENU_DBORDER_SIZE 1

//typedef void (*kmenuitem_callback_t)(void);

typedef struct kmenuitem_t{
	int type;
	char *text;
	union {
		void *submenu;		
		//kmenuitem_callback_t callback;
		size_t btnid;
	};
	
	void (__stdcall *paint)(struct kmenuitem_t *item, t_rect *rc);
	
	int is_focused;
	int is_enabled;
	int is_visible;
	
	size_t left, top;
	size_t width, height;
	size_t margin_left, margin_right, margin_top, margin_bottom;
	size_t padding_left, padding_right, padding_top, padding_bottom;
} kmenuitem_t;

typedef struct {
	kmenuitem_t **items;
	int count;
	
	int is_opened;
	int focus_idx;
	
	size_t width, height;
	size_t left, top;
	int tid;
	int parent_wnd, parent_tid, submenu_tid;
	int level;
	size_t return_btnid;
} ksubmenu_t;

typedef struct {
	kmenuitem_t *submenu;
	int count;
	
	int height;
	int width;
	
	int line_height;
} kmenu_t;

void kmenu_init(t_system_colors *colors);

kmenu_t * kmenu_new(void);
void kmenu_delete(kmenu_t *menu);
void kmenu_dispatch_event(kmenu_t *menu, int event);
void kmenu_add(kmenu_t *menu, ksubmenu_t *submenu);
void kmenu_draw(kmenu_t *menu, int level);

ksubmenu_t * ksubmenu_new(void);
void ksubmenu_delete(ksubmenu_t *menu);
int ksubmenu_draw(ksubmenu_t *menu, t_point *pt, int level);
//int ksubmenu_dispatch_event(ksubmenu_t *menu, int event);
void ksubmenu_add(ksubmenu_t *menu, kmenuitem_t *menuitem);

kmenuitem_t * kmenuitem_new(int type, char *text, void *data);
void kmenuitem_delete(kmenuitem_t *item);
void kmenuitem_draw(kmenuitem_t *item, t_rect *rc);
//void kmenuitem_dispatch_event(kmenuitem_t *item, int event);
size_t kmenuitem_get_preffered_width(kmenuitem_t *item);
size_t kmenuitem_get_preffered_height(kmenuitem_t *item);
